#[cfg(target_arch = "x86_64")]
pub use super::x86_64::io::*;

pub mod serial {
    #[cfg(target_arch = "x86_64")]
    pub use super::super::x86_64::io::*;

    pub fn write(s: &str) -> () {
        for byte in s.bytes() {
            match byte {
                0x20..=0x7e | b'\n' => serial::putchar(byte),
                _ => serial::putchar(0xfe),
            }
        }
    }
}

use core::fmt;

pub struct Serial
{

}

impl fmt::Write for Serial {
    fn write_str(&mut self, s: &str) -> fmt::Result {
        serial::write(s);
        Ok(())
    }
}

use spin::Mutex;

pub static SERIAL: Mutex<Serial> = Mutex::new(Serial {});