#![no_std]
#![no_main]

#![feature(core_intrinsics)]
#![feature(abi_x86_interrupt)]

mod video;
mod bootboot;
mod panic;
mod util;
mod init;
mod arch;
mod log;

use arch::cpu;
use arch::interrupts;

use video::Color;

#[no_mangle]
pub extern "C" fn _start() -> ! {

    interrupts::disable();

    init::halt_other_cores();
    init::check_magic();

    cpu::platform_init();

    interrupts::load();

    video::clear(Color::White);

    println!("Hello, world!");

    interrupts::enable();

    cpu::breakpoint();

    println!("Still here!");
    
    cpu::halt();

}