use core::panic::PanicInfo;

use crate::try_println;
use crate::arch::io::SERIAL;
use crate::arch::cpu;

#[panic_handler]
fn panic(info: &PanicInfo) -> ! {
    unsafe { SERIAL.force_unlock(); } // since we're panicking, this is not relevant anymore.
    try_println!("Kernel {}", info); // we probably should succeed, unless another CPU locked the serial port just after we unlocked it but before try_println attempts to lock it.
    cpu::halt();
}